import { Result } from "structural-adts";
export { raw, parse };
declare type ArgsConfig = Record<string, ArgConfig>;
declare type ArgConfig = FlagArg | NamedArg | PositionalArg;
declare type FlagArg = {
    kind: "flag";
    match: string;
};
declare type NamedArg = {
    kind: "named";
    match: string;
};
declare type PositionalArg = {
    kind: "positional";
};
declare type ParsedArgs<Config extends ArgsConfig> = {
    [k in keyof Config]: Config[k] extends FlagArg ? boolean : Config[k] extends NamedArg ? string | undefined : Config[k] extends PositionalArg ? string[] : never;
};
declare const raw: string[];
declare const parse: <Config extends Record<string, ArgConfig>>(config: Config) => Result.Result<ParsedArgs<Config>, string>;
